Option Strict On
Option Explicit On
'
' $Id: PerformanceTest64.vb 1.7 2014-06-18 13:09:18-04 Ron Exp $ $Name: release1dot7 $
'
Module Performance_Test64
	'  by Ron Charlton for Visual Basic .NET.
	' For results, see file mt19937-64.vb comments under "PERFORMANCE:".
	Public Sub PerformanceTest64()
		Const Max As Integer = 100000000	  'CHANGE THIS VALUE AS NEEDED
		Dim ii As Integer, beginSeconds, endSeconds, delta As Double

		Dim a As New MTRandom64()

		Console.WriteLine("")
		Console.WriteLine("Timing the generation of {0:E} random numbers.", Max)
		Console.WriteLine("Ctrl+C to interrupt...")

		beginSeconds = DateAndTime.Timer
		For ii = 1 To Max
			' (assignment [=] is not required here)
			a.genrand64_int64()	  ' USE ANY *ONE* OF THE MTRandom64 FUNCTIONS
			'a.genrand64_int63()
			'a.genrand64_real1()
			'a.genrand64_real2()
			'a.genrand64_real3()
			'a.genrand64_intMax(1000UL)
			'a.genrand64_intMax(&H5FFFFFFFUL)
			'a.genrand64_intRange(10UL, 20UL)
			'a.genrand64_int128SignedInt()
		Next
		endSeconds = DateAndTime.Timer

		delta = endSeconds - beginSeconds

		' Did we cross midnight? Then correct with the number of seconds per day.
		If delta < 0.0 Then delta += 86400.0

		Console.WriteLine("Elapsed time in seconds for generating {0:E} numbers: {1}", Max, delta)
		Console.WriteLine("Nanoseconds per call: {0}.", delta / Max * 1000000000.0)
		Console.WriteLine("Calls per second: {0:N}.", Max / delta)

		' Prevent the window from closing in the Visual Basic .NET IDE.
		Console.WriteLine("Press the <Enter> key to continue.")
		Console.ReadLine()
	End Sub	'PerformanceTest64
End Module